/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _COLORDIALOGPREFS_H_
#define _COLORDIALOGPREFS_H_

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <string>

class ColorDPUnit
{
 private:
  double cols[4];
 public:
  ColorDPUnit(int r, int g, int b)
    {
      cols[0] = (double)r / 65535.0;
      cols[1] = (double)g / 65535.0;
      cols[2] = (double)b / 65535.0;
    }
  void getColors(int& r, int& g, int& b)
    {
      r = (guint16)(cols[0]*65535.0);
      g = (guint16)(cols[1]*65535.0);
      b = (guint16)(cols[2]*65535.0);
    }
  double* getArray()
    {
      return cols;
    }
};

class ColorDialogPrefs
{
  ColorDPUnit Color;
  GtkWidget* colMain;
  bool Visible;
 public:
  ColorDialogPrefs(const char* title, ColorDPUnit color);
  ~ColorDialogPrefs();
  void show();
  void hide();
  void ok();
  void cancel();
  void getColors(int& r, int& g, int& b)
    {
      Color.getColors(r,g,b);
    }

};


#endif
