/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _GNOMEGUIPLAYER_H_
#define _GNOMEGUIPLAYER_H_

#include "MidnightGUIPlayer.h"
#include "Common.h"

#ifdef MIDNIGHT_USE_GNOME
#  include "gnome.h"
#endif

class GnomeGUIPlayer : public MidnightGUIPlayer
{
  GtkWidget* _commandToolbar;
  GtkWidget*  _tbHasTextCheckMenuItem;

 public:
  GnomeGUIPlayer(MidnightPlayerManager* manager);
  virtual void init();
  virtual ~GnomeGUIPlayer();
  void setToolbarHasText(gboolean b);
  void setRememberLayout(gboolean b);

 protected:
  virtual void initAddCommands(GtkWidget* main, GtkWidget* vbox);
  virtual void initMainWindow();
  virtual void attachContentToMain(GtkWidget* vbox);
  virtual void attachMenuToMain(GtkWidget* main, GtkWidget* vbox);

  virtual void setPlayPixAsPlay();// { gtk_pixmap_set( GTK_PIXMAP(_playPixmap), _gdkpixPlay, _gdkpixPlayMask); }
  virtual void setPlayPixAsPause();// { gtk_pixmap_set( GTK_PIXMAP(_playPixmap), _gdkpixPause, _gdkpixPauseMask); }

  virtual void showKaraokePrefs();  

};

#endif
