/*
  Midnight, a C++ midi library to load and play midi files.
  Copyright (C) 1999 Rodrigo Reyes, reyes@chez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "MidnightMidiPlayer.h"
#include "MidnightGUIPlayer.h"

#include <iostream>
#include <fstream>

#define PROGRAM_NAME "xmidnight"
#include "Common.h"

int main(int argc, char **argv)
{

  // 
  // Start the gtk engine, and construct the player
  //
  gtk_init(&argc, &argv);

  //
  // Load the user's prefs and creates the players
  //
  MidnightConfiguration config( MidnightConfiguration::getDefaultConfFile().c_str() );
  MidnightPlayerManager manager(&config);
  MidnightGUIPlayer gui(&manager);
  gui.init();
  
  gui.setSongInfo(PROGRAM_NAME " " PROGRAM_VERSION " Copyright Rodrigo Reyes 1999\n"
		  PROGRAM_NAME " comes with ABSOLUTELY NO WARRANTY; "
		  "This is free software, and you are welcome to redistribute it"
		  " under certain conditions.");

  gtk_main();
  return 0;
}

